<script lang="ts" setup>
import { ChevronLgRight } from 'slippers-ui/icons';
interface sectionCta {
  text: string;
  config: {
    href: string;
    dataGaName?: string;
    dataGaLocation?: string;
  };
}

const props = defineProps({
  overview: {
    type: Object as PropType<{
      header: string;
      text: string;
      id: string;
    }>,
    required: false,
    default: null,
  },
  sections: {
    type: Array as PropType<
      {
        header: string;
        name: string;
        description?: string;
        id: string;
        blocks?: {
          header: string;
          description: string;
          primaryButton?: sectionCta;
          secondaryButton?: sectionCta;
        }[];
      }[]
    >,
    required: true,
  },
});

const { isMobile } = useCheckIfMobile();

const navLinks = computed(() => {
  return [
    props.overview && {
      text: props.overview.header,
      id: `${props.overview.id}`,
    },
    ...props.sections.map((section) => ({
      text: section.name,
      id: `${section.id}`,
    })),
  ];
});

const tabs = computed(() => props.sections.map((section) => section.name));

const selectedTab = ref(0);

function changeTab(newTab: number) {
  selectedTab.value = newTab;
}
</script>

<template>
  <SlpSection background-color="#f6f3fe" class="esg-showcase">
    <SlpContainer>
      <SlpSideNavigation :navigation-items="navLinks">
        <div class="content">
          <div v-if="overview" :id="overview.id" class="overview">
            <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-24">{{ overview.header }}</SlpTypography>
            <SlpTypography variant="heading5" tag="p">{{ overview.text }}</SlpTypography>
          </div>
          <CommonTabs v-if="isMobile" :tabs="tabs" :selected-tab="selectedTab" class="tabs" @change="changeTab" />
          <div
            v-for="(section, sectionIndex) in sections"
            v-show="!isMobile || (isMobile && sectionIndex === selectedTab)"
            :id="section.name.toLowerCase()"
            :key="section.name"
            class="section"
          >
            <div class="section__main-content">
              <SlpTypography v-if="section.header" variant="heading3-bold" tag="h2" class="slp-mb-48">
                {{ section.header }}
              </SlpTypography>
              <SlpTypography v-if="section.description" variant="body1" tag="p" class="slp-mt-48">
                {{ section.description }}
              </SlpTypography>
            </div>
            <div class="section__cards">
              <div v-for="block in section.blocks" :key="block.header" class="esg-block">
                <div class="text">
                  <SlpTypography variant="heading5-bold" tag="h3">
                    {{ block.header }}
                  </SlpTypography>
                  <SlpTypography variant="body1" tag="div" class="description">
                    <div v-html="$md.render(block.description)"></div>
                  </SlpTypography>
                  <div>
                    <SlpButton
                      v-if="block.primaryButton"
                      variant="tertiary"
                      :href="block.primaryButton.config.href"
                      :data-ga-name="block.primaryButton.config.dataGaName"
                      :data-ga-location="block.primaryButton.config.dataGaLocation"
                      >{{ block.primaryButton.text }} <SlpIcon :icon="ChevronLgRight"
                    /></SlpButton>
                    <SlpButton
                      v-if="block.secondaryButton"
                      variant="tertiary"
                      :href="block.secondaryButton.config.href"
                      :data-ga-name="block.secondaryButton.config.dataGaName"
                      :data-ga-location="block.secondaryButton.config.dataGaLocation"
                      >{{ block.secondaryButton.text }} <SlpIcon :icon="ChevronLgRight"
                    /></SlpButton>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </SlpSideNavigation>
    </SlpContainer>
  </SlpSection>
</template>

<style lang="scss" scoped>
.esg-showcase {
  display: block;
  background-color: #f6f3fe;
  margin: 64px 0;
  @media (min-width: $breakpoint-lg) {
    padding: 96px 0;
    margin-top: 120px 0;
  }
}
.tabs {
  @media (min-width: $breakpoint-lg) {
    display: none;
  }
}
.content {
  @media (min-width: $breakpoint-lg) {
    padding: 0 64px;
  }
}
.overview {
  padding-bottom: 64px;
  @media (min-width: $breakpoint-lg) {
    max-width: 60%;
  }
}
.section {
  padding: 32px;
  max-width: 100%;
  background-color: #fff;
  margin-bottom: 64px;
  border-radius: 8px;
  max-width: 100%;

  @media (max-width: $breakpoint-md) {
    overflow-x: scroll;
  }
  &__cards {
    display: flex;
    flex-direction: column;
    gap: 48px;

    @media (max-width: $breakpoint-md) {
      flex-direction: row;
      flex-wrap: nowrap;

      gap: 16px;
    }
  }
  &.purple-background {
    position: relative;
    &::after {
      content: '';
      height: 100%;
      left: -50vw;
      position: absolute;
      top: 0;
      width: 200vw;
      z-index: -1;
    }
  }
  &__main-content {
    flex-break: after;
  }
}
.esg-block {
  display: flex;
  flex-direction: row;
  gap: 64px;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
    gap: 64px;
  }
  @media (max-width: $breakpoint-lg) {
    min-width: 100%;
  }
  .text {
    display: flex;
    flex-direction: column;
    gap: 16px;
    @media (max-width: $breakpoint-md) {
      padding: 0 32px 0 0;
    }
  }
  .image img {
    border-radius: 0px 0px 82px 4px;
    object-fit: cover;
    max-width: 100%;
    width: 100%;
    @media (min-width: $breakpoint-lg) {
      border-radius: 4px 4px 82px 4px;
      width: 375px;
      height: 314px;
      max-width: unset;
    }
  }
}
.description:deep(a) {
  color: $color-primary-200;
  text-decoration: underline;
  text-decoration-color: currentColor;
  transition: all 0.3s ease;
  &:hover,
  &:focus {
    text-decoration-color: transparent;
  }
}
</style>
